Lattice Grid Buy a licence

react data grid · kpi tiles

React Grid: KPI Tiles

A row of live figures beside the grid, reading the same rows it holds: a running total, an average measured against a baseline, a count that changes colour past a threshold, and a sparkline, all moving together as the data changes.

Also in: Angular

Install and import

npm install @toclocoinc/lattice-grid
# free on localhost; a production domain needs a licence key (see /pricing/)

The files

lattice.ts

// lattice.ts
import React from 'react';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createKPI } from '@toclocoinc/lattice-grid/modules/kpi';
import { createLatticeReact } from '@toclocoinc/lattice-grid/modules/react';

export const { LatticeGrid, LatticeKPI } = createLatticeReact({ React, createGrid, createKPI });

Pipeline.tsx

// Pipeline.tsx
import React from 'react';
import { createRoot } from 'react-dom/client';
import { LatticeGrid, LatticeKPI } from './lattice';

const MONEY = { style: 'currency', currency: 'USD', decimals: 0 };
const OPEN = { warn: 14, critical: 22, direction: 'lowerIsBetter' };

const columns = [
  { field: 'id', title: 'Ref', layout: { width: 96, pin: 'start' } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'stage', title: 'Stage', filter: { type: 'set' } },
  { field: 'value', title: 'Value', type: 'number', format: MONEY, total: 'sum' },
];

const rows = [/* deal records: id, region, stage, value */];

// Each tile is an aggregate over the same rows: a running total, an average
// against a baseline, a count with a good/warn/critical band, and a
// sparkline over the biggest deal.
const tiles = [
  { id: 'revenue', label: 'Pipeline value', aggregation: 'sum', field: 'value', format: 'currency' },
  { id: 'avg', label: 'Average deal vs $12k', aggregation: 'avg', field: 'value', format: { type: 'currency', decimals: 0 }, baseline: 12000 },
  { id: 'open', label: 'Still open', aggregation: 'count', filter: (r: any) => r.stage !== 'won', thresholds: OPEN },
  { id: 'biggest', label: 'Biggest deal', aggregation: 'max', field: 'value', format: 'currency', sparkline: 'value' },
];

function Pipeline() {
  const [grid, setGrid] = React.useState<any>(null);

  // The KPI panel takes the live grid as a prop, once the grid reports it is
  // ready, and reads the same rows a chart or a board would.
  return (
    <>
      {grid && <LatticeKPI grid={grid} columns={4} tiles={tiles} style={{ marginBottom: 12 }} />}
      <LatticeGrid rowKey="id" columns={columns} rows={rows} onGridReady={setGrid} style={{ height: '320px' }} />
    </>
  );
}

createRoot(document.getElementById('pipeline')!).render(<Pipeline />);

See it running

Building…
Loading a live grid…

Open this demo's React tab →

Working in React

createLatticeReact, not createLatticeGrid alone. A KPI panel is a second component, built from the same call as the grid so both share one React and one createGrid. Import only createKPI alongside it and nothing else about a board, a chart or the Gantt is pulled in.

The panel waits for its grid. A template ref cannot tell a sibling the grid has arrived, because writing to a ref re-renders nobody; onGridReady is the documented way a KPI panel (or a chart) learns which instance to read, which is why <LatticeKPI> is only rendered once grid is set.

Tiles update on a grid event, not a React one. A tile recomputes when the grid's own rows or filter changes, so filtering the grid moves every tile automatically, with no state of your own to keep in sync.

Related

Lattice Grid Buy a licence

angular data grid · kpi tiles

Angular Grid: KPI Tiles

A row of live figures beside the grid, reading the same rows it holds: a running total, an average measured against a baseline, a count that changes colour past a threshold, and a sparkline, moving together as the data changes.

Also in: React

Install and import

npm install @toclocoinc/lattice-grid
# free on localhost; a production domain needs a licence key (see /pricing/)

The file

pipeline.component.ts

// pipeline.component.ts
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createKPI } from '@toclocoinc/lattice-grid/modules/kpi';
import { LatticeGridComponent, LatticeKpiComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

const MONEY = { style: 'currency', currency: 'USD', decimals: 0 };
const OPEN = { warn: 14, critical: 22, direction: 'lowerIsBetter' };

@Component({
  selector: 'app-pipeline',
  standalone: true,
  imports: [LatticeGridComponent, LatticeKpiComponent],
  template:
    '<lattice-kpi [config]="kpiConfig" style="display:block;margin-bottom:12px"></lattice-kpi>' +
    '<lattice-grid [config]="gridConfig" style="display:block;height:320px"></lattice-grid>',
})
export class PipelineComponent {
  // Both the grid and the panel read and publish the page's one
  // default-named grid, so neither side has to name it explicitly.
  gridConfig = {
    rowKey: 'id',
    columns: [
      { field: 'id', title: 'Ref', layout: { width: 96, pin: 'start' } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'stage', title: 'Stage', filter: { type: 'set' } },
      { field: 'value', title: 'Value', type: 'number', format: MONEY, total: 'sum' },
    ],
    rows: [] as unknown[], // deal records: id, region, stage, value
  };

  // A running total, an average against a baseline, a count with a
  // good/warn/critical band, and a sparkline over the biggest deal.
  kpiConfig = {
    columns: 4,
    tiles: [
      { id: 'revenue', label: 'Pipeline value', aggregation: 'sum', field: 'value', format: 'currency' },
      { id: 'avg', label: 'Average deal vs $12k', aggregation: 'avg', field: 'value', format: { type: 'currency', decimals: 0 }, baseline: 12000 },
      { id: 'open', label: 'Still open', aggregation: 'count', filter: (r: any) => r.stage !== 'won', thresholds: OPEN },
      { id: 'biggest', label: 'Biggest deal', aggregation: 'max', field: 'value', format: 'currency', sparkline: 'value' },
    ],
  };
}

bootstrapApplication(PipelineComponent, {
  providers: [provideLattice({ createGrid, createKPI })],
});

See it running

Building…
Loading a live grid…

Open this demo's Angular tab →

Working in Angular

No explicit link between the two components. Both <lattice-grid> and <lattice-kpi> publish to and read from the same default-named grid registry, so as long as neither names a different name or gridName, the panel finds the grid on its own.

The panel waits for its grid. Nothing is built until the grid it needs exists, so a <lattice-kpi> written above its <lattice-grid> in the template still renders correctly once the grid arrives.

Tiles update on a grid event, not a change-detection cycle. A tile recomputes when the grid's own rows or filter changes, so filtering the grid moves every tile with no field of your own to keep in sync.

Related